<template>
  <div class="modal" :class="{ 'is-active': show }">
    <div class="modal-background" @click="$emit('update:show', false)" />
    <div class="modal-content">
      <div class="card">
        <div class="card-content">
          <div class="content">
            <p>You are going to delete {{ type }} <strong>{{ name }}</strong>.</p>
            <p>Please type <code>Delete</code> to confirm.</p>
            <div class="field">
              <div class="control">
                <input class="input" placeholder="Type 'Delete'" v-model="confirm">
              </div>
            </div>
            <div class="buttons">
              <button
                @click="$emit('remove')"
                class="button is-primary"
                :disabled="confirm !== 'Delete'"
                :loading="loading"
              >Delete</button>
              <button class="button is-primary" @click="$emit('update:show', false)">Cancel</button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <button
      class="modal-close is-large"
      aria-label="close"
      @click="$emit('update:show', false)"
    />
  </div>
</template>

<script lang="ts">
  import { Vue, Component, Prop } from 'vue-property-decorator';

  @Component<DeleteConfirm>({})
  export default class DeleteConfirm extends Vue {
    @Prop({
      type: Boolean,
      default: false,
    }) loading!: boolean;

    @Prop({
      type: Boolean,
      required: true,
    }) show!: boolean;

    @Prop({
      type: String,
      required: true,
    }) name!: string;

    @Prop({
      type: String,
      required: true,
    }) type!: string;

    confirm: string = '';
  }
</script>
